> ## Documentation Index
> Fetch the complete documentation index at: https://www.latitude.sh/docs/llms.txt
> Use this file to discover all available pages before exploring further.

# Run VM power action

> Performs a power action on a given virtual machine:
- `power_on` - Starts the virtual machine
- `power_off` - Stops the virtual machine
- `reboot` - Restarts the virtual machine




## OpenAPI

````yaml https://spec.speakeasy.com/latitude/latitude/latitude-sh-api-with-code-samples post /virtual_machines/{virtual_machine_id}/actions
openapi: 3.0.1
info:
  title: Latitude.sh API
  version: '2023-06-01'
  description: >-
    The Latitude.sh API is a RESTful API to manage your Latitude.sh account. It
    allows you to perform the same actions as the Latitude.sh dashboard.
servers:
  - url: https://api.latitude.sh
    variables:
      latitude_api_key:
        default: <insert your api key here>
  - url: http://api.latitude.sh
    variables:
      latitude_api_key:
        default: <insert your api key here>
security: []
tags:
  - name: API keys
  - name: Billing
  - name: Elastic Ips
  - name: Events
  - name: Firewalls
  - name: IP Addresses
  - name: Kubernetes Clusters
  - name: Operating Systems
  - name: Plans
  - name: Private Networks
  - name: Projects
  - name: Regions
  - name: Roles
  - name: SSH Keys
  - name: Servers
  - name: Storage
  - name: Tags
  - name: Teams
  - name: Team members
  - name: Traffic
  - name: User data
  - name: User profile
  - name: VPN Sessions
  - name: Virtual machines
paths:
  /virtual_machines/{virtual_machine_id}/actions:
    post:
      tags:
        - Virtual machines
      summary: Run VM power action
      description: |
        Performs a power action on a given virtual machine:
        - `power_on` - Starts the virtual machine
        - `power_off` - Stops the virtual machine
        - `reboot` - Restarts the virtual machine
      operationId: create-virtual-machine-action
      parameters:
        - name: virtual_machine_id
          in: path
          required: true
          examples:
            Created:
              value: vm_5LA73qkjdaJ2o
          schema:
            type: string
      requestBody:
        content:
          application/json:
            schema:
              type: object
              properties:
                id:
                  type: string
                type:
                  type: string
                  enum:
                    - virtual_machines
                attributes:
                  type: object
                  properties:
                    action:
                      type: string
                      description: The action to perform on the virtual machine
                      enum:
                        - power_on
                        - power_off
                        - reboot
                  required:
                    - action
              required:
                - id
                - type
                - attributes
            examples:
              Created:
                summary: Created
                value:
                  id: vm_5LA73qkjdaJ2o
                  type: virtual_machines
                  attributes:
                    action: reboot
          application/vnd.api+json:
            schema:
              type: object
              properties:
                id:
                  type: string
                type:
                  type: string
                  enum:
                    - virtual_machines
                attributes:
                  type: object
                  properties:
                    action:
                      type: string
                      description: The action to perform on the virtual machine
                      enum:
                        - power_on
                        - power_off
                        - reboot
                  required:
                    - action
              required:
                - id
                - type
                - attributes
            examples:
              Created:
                summary: Created
                value:
                  id: vm_5LA73qkjdaJ2o
                  type: virtual_machines
                  attributes:
                    action: reboot
        required: true
      responses:
        '201':
          description: Created
          content:
            application/vnd.api+json:
              examples:
                Created:
                  value:
                    data:
                      id: act_5LA73qkjdaJ2o
                      type: actions
                      attributes:
                        status: Rebooting virtual machine
      security:
        - Bearer: []
      x-codeSamples:
        - lang: python
          label: Python (SDK)
          source: |-
            import latitudesh_python_sdk
            from latitudesh_python_sdk import Latitudesh
            import os


            with Latitudesh(
                bearer=os.getenv("LATITUDESH_BEARER", ""),
            ) as latitudesh:

                latitudesh.virtual_machines.create_virtual_machine_action(virtual_machine_id="vm_5LA73qkjdaJ2o", id="vm_5LA73qkjdaJ2o", type_=latitudesh_python_sdk.CreateVirtualMachineActionVirtualMachinesType.VIRTUAL_MACHINES, attributes={
                    "action": latitudesh_python_sdk.CreateVirtualMachineActionVirtualMachinesAction.REBOOT,
                })

                # Use the SDK ...
        - lang: go
          label: Go (SDK)
          source: "package main\n\nimport(\n\t\"context\"\n\t\"os\"\n\tlatitudeshgosdk \"github.com/latitudesh/latitudesh-go-sdk\"\n\t\"github.com/latitudesh/latitudesh-go-sdk/models/operations\"\n\t\"log\"\n)\n\nfunc main() {\n    ctx := context.Background()\n\n    s := latitudeshgosdk.New(\n        latitudeshgosdk.WithSecurity(os.Getenv(\"LATITUDESH_BEARER\")),\n    )\n\n    res, err := s.VirtualMachines.CreateVirtualMachineAction(ctx, \"vm_5LA73qkjdaJ2o\", operations.CreateVirtualMachineActionVirtualMachinesRequestBody{\n        ID: \"vm_5LA73qkjdaJ2o\",\n        Type: operations.CreateVirtualMachineActionVirtualMachinesTypeVirtualMachines,\n        Attributes: operations.CreateVirtualMachineActionVirtualMachinesAttributes{\n            Action: operations.CreateVirtualMachineActionVirtualMachinesActionReboot,\n        },\n    })\n    if err != nil {\n        log.Fatal(err)\n    }\n    if res != nil {\n        // handle response\n    }\n}"
        - lang: typescript
          label: Typescript (SDK)
          source: |-
            import { Latitudesh } from "latitudesh-typescript-sdk";

            const latitudesh = new Latitudesh({
              bearer: process.env["LATITUDESH_BEARER"] ?? "",
            });

            async function run() {
              await latitudesh.virtualMachines.createVirtualMachineAction({
                virtualMachineId: "vm_5LA73qkjdaJ2o",
                requestBody: {
                  id: "vm_5LA73qkjdaJ2o",
                  type: "virtual_machines",
                  attributes: {
                    action: "reboot",
                  },
                },
              });


            }

            run();
components:
  securitySchemes:
    Bearer:
      type: apiKey
      name: Authorization
      in: header

````